\name{CorTumNorm}
\alias{CorTumNorm}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{A function to compute correlations between tumor and smoothed calibration profiles}
\description{A function to compute Pearson correlations between tumor and smoothed calibration profiles}

\usage{
CorTumNorm(CGHTumor, CGHNormal)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{CGHTumor}{Matrix containing 3 or 4 probe information columns, followed by log2-ratio data for each tumor profile}
  \item{CGHNormal}{Matrix containing 3 or 4 probe information columns, followed by the (smoothed) calibration data for each normal profile}
}
\details{
  This function may be used to judge to what extent the calibration profiles can be useful to de-wave the tumor set at hand. 
  Data matrices may contain missings. Correlations are estimated using pairwise complete data. 
}
\value{
  A correlation matrix of which the rows and columns represent the tumor and calibration profiles, respectively. 
}
\author{Mark van de Wiel }

% \seealso{See Also \code{\link{SmoothNormals}}}
\examples{
data(pdatanormsmooth)
data(pdatatum)
CorTumNorm(pdatatum,pdatanormsmooth)
}
\keyword{multivariate}
