\name{pdatanorm}
\alias{pdatanorm}
\docType{data}
\title{Calibration array CGH data}
\description{Calibration array CGH data, Agilent 44K.
}
\usage{data(pdatanorm)}
\format{
  A data frame with 43026 observations on the following 9 variables.
  \describe{
    \item{\code{Name}}{a factor containing probe names}
    \item{\code{Chromosome}}{a numeric vector containing chromosome numbers}
    \item{\code{Position}}{a numeric vector containing start basepair position}
    \item{\code{X68_251495010771_S01_CGH.v4_91_1_2}}{a numeric vector}
    \item{\code{X79_251495010768_S01_CGH.v4_91_1_2}}{a numeric vector}
    \item{\code{X80_251495010768_S01_CGH.v4_91_1_3}}{a numeric vector}
    \item{\code{X83_251495010769_S01_CGH.v4_91_1_1}}{a numeric vector}
    \item{\code{X88_251495010770_S01_CGH.v4_91_1_3}}{a numeric vector}
    \item{\code{X97_251495010774_S01_CGH.v4_91_1_1}}{a numeric vector}
  }
}
\details{
 These data may be used to de-wave the pdatatum tumor data set after smoothing the pdatanorm (the smoothed object 
 is available as pdatanormsmooth). A more complete calibration set (Agilent 44K) is available from the web site}
\source{\begin{verbatim}www.few.vu.nl/~mavdwiel/nowaves.html\end{verbatim}}
}
\examples{
data(pdatanorm)
}
\keyword{datasets}
