\name{pdatanormsmooth}
\alias{pdatanormsmooth}
\docType{data}
\title{Smoothed calibration array CGH data}
\description{Smoothed calibration array CGH data, Agilent 44K.
  }
\usage{data(pdatanormsmooth)}
\format{
  A data frame with 42888 observations on the following 9 variables.
  \describe{
   \item{\code{Name}}{a factor containing probe names}
    \item{\code{Chromosome}}{a numeric vector containing chromosome numbers}
    \item{\code{Position}}{a numeric vector containing start basepair position}
     \item{\code{X68_251495010771_S01_CGH.v4_91_1_2}}{a numeric vector}
    \item{\code{X79_251495010768_S01_CGH.v4_91_1_2}}{a numeric vector}
    \item{\code{X80_251495010768_S01_CGH.v4_91_1_3}}{a numeric vector}
    \item{\code{X83_251495010769_S01_CGH.v4_91_1_1}}{a numeric vector}
    \item{\code{X88_251495010770_S01_CGH.v4_91_1_3}}{a numeric vector}
    \item{\code{X97_251495010774_S01_CGH.v4_91_1_1}}{a numeric vector}
  }
}
\details{pdatanormsmooth is the result from applying the function SmoothNormals to pdatanorm. Note that probes from
chromosome 24 are deleted. This data set can be used as input for the function CorrectTumors.
A more complete calibration set (Agilent 44K) is available from the web site}

\source{\begin{verbatim}www.few.vu.nl/~mavdwiel/nowaves.html\end{verbatim}}


\examples{
data(pdatanormsmooth)
}
\keyword{datasets}
